# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['sqlalchemy_dantic']

package_data = \
{'': ['*']}

install_requires = \
['pydantic>=1.5.1,<2.0.0', 'sqlalchemy>=1.3.16,<2.0.0']

setup_kwargs = {
    'name': 'sqlalchemy-dantic',
    'version': '0.2.0',
    'description': "Tools to convert SQLAlchemy models to Pydantic models.Thanks project 'pydantic-sqlalchemy'.",
    'long_description': '# Pydantic-SQLAlchemy\n\n<a href="https://github.com/Chise1/pydantic-sqlalchemy/actions?query=workflow%3ATest" target="_blank">\n    <img src="https://github.com/Chise1/pydantic-sqlalchemy/workflows/Test/badge.svg" alt="Test">\n</a>\n<a href="https://codecov.io/gh/Chise1/pydantic-sqlalchemy" target="_blank">\n    <img src="https://img.shields.io/codecov/c/github/Chise1/pydantic-sqlalchemy?color=%2334D058" alt="Coverage">\n</a>\n<a href="https://pypi.org/project/sqlalchemy-dantic" target="_blank">\n    <img src="https://img.shields.io/pypi/v/sqlalchemy-dantic?color=%2334D058&label=pypi%20package" alt="Package version">\n</a>\n\nTools to generate Pydantic models from SQLAlchemy models.\n\nStill experimental.\n## Install\n```shell script\npip3 install sqlalchemy-dantic\n```\n\n## How to use\n\nQuick example:\n\n```Python\nfrom typing import List\n\nfrom sqlalchemy_dantic import sqlalchemy_to_pydantic\nfrom sqlalchemy import Column, ForeignKey, Integer, String, create_engine\nfrom sqlalchemy.ext.declarative import declarative_base\nfrom sqlalchemy.orm import Session, relationship, sessionmaker\n\nBase = declarative_base()\n\nengine = create_engine("sqlite://", echo=True)\n\n\nclass User(Base):\n    __tablename__ = "users"\n\n    id = Column(Integer, primary_key=True)\n    name = Column(String)\n    fullname = Column(String)\n    nickname = Column(String)\n\n    addresses = relationship(\n        "Address", back_populates="user", cascade="all, delete, delete-orphan"\n    )\n\n\nclass Address(Base):\n    __tablename__ = "addresses"\n    id = Column(Integer, primary_key=True)\n    email_address = Column(String, nullable=False)\n    user_id = Column(Integer, ForeignKey("users.id"))\n\n    user = relationship("User", back_populates="addresses")\n\n\nPydanticUser = sqlalchemy_to_pydantic(User,name="PydanticUser")\nPydanticAddress = sqlalchemy_to_pydantic(Address,name="PydanticAddress")\n\n\nclass PydanticUserWithAddresses(PydanticUser):\n    addresses: List[PydanticAddress] = []\n\n\nBase.metadata.create_all(engine)\n\n\nLocalSession = sessionmaker(bind=engine)\n\ndb: Session = LocalSession()\n\ned_user = User(name="ed", fullname="Ed Jones", nickname="edsnickname")\n\naddress = Address(email_address="ed@example.com")\naddress2 = Address(email_address="eddy@example.com")\ned_user.addresses = [address, address2]\ndb.add(ed_user)\ndb.commit()\n\n\ndef test_sqlalchemy_dantic():\n    user = db.query(User).first()\n    pydantic_user = PydanticUser.from_orm(user)\n    data = pydantic_user.dict()\n    assert data == {\n        "fullname": "Ed Jones",\n        "id": 1,\n        "name": "ed",\n        "nickname": "edsnickname",\n    }\n    pydantic_user_with_addresses = PydanticUserWithAddresses.from_orm(user)\n    data = pydantic_user_with_addresses.dict()\n    assert data == {\n        "fullname": "Ed Jones",\n        "id": 1,\n        "name": "ed",\n        "nickname": "edsnickname",\n        "addresses": [\n            {"email_address": "ed@example.com", "id": 1, "user_id": 1},\n            {"email_address": "eddy@example.com", "id": 2, "user_id": 1},\n        ],\n    }\n```\n\n## Release Notes\n### add sub Schema .\n## License\n\nThis project is licensed under the terms of the MIT license.\n',
    'author': 'Chise1',
    'author_email': 'chise123@live.com',
    'maintainer': None,
    'maintainer_email': None,
    'url': None,
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.6,<4.0',
}


setup(**setup_kwargs)
